# ACaesar - Caesar cipher transcoder

This program encodes and decodes messages using a [Caesar Cipher](https://en.wikipedia.org/wiki/Caesar_cipher).

```
Usage: acaesar [options] message
Options:
   --help             Print this help message
   -o <offset>        Set the integer offset used in transcoding
   -c <character set> Set the character set
   --xyz              Set the character set to the lowercase alphabet (default)
```

## Compiling

The program is fairly simple and thus it should be able to be compiled with any modern C compiler. This was developed using GCC on Ubuntu. A makefile is included which has only one command:

```
gcc acaesar.c utf8hack.c -O3 -Wall -Wextra -o acaesar
```
